


.equ pga_clk=$20;	Clock at Bit 5
.equ pga_do =$10;	Clock at Bit 4
.equ pga_cs =$08;	Clock at Bit 3

.equ pga_clk_bit=5;
.equ pga_do_bit =4;
.equ pga_cs_bit =3;

;************ setting I/O Ports for PGA ***********
pga_init:

ldi r16,$38;
out DDRD,r16;		Set Ports as output
sbi PORTD,pga_cs_bit;    Set CS=High
ret;




;************* set PGA Volume *********************
;*** r0=Volume (R&L)  *****************************

pga_sendvol:

cbi PORTD,pga_cs_bit;    Set CS =LOW
cbi PORTD,pga_clk_bit;   Set CLK=LOW
; Send 2 x r0, MSB first

mov r16,r0;		Load the vol value into shift register
ldi r17,8;	        Set counter to 8
ldi r18,2;		Set Loopcounter to 2

pga_sv_loop1:
sbi PORTD,pga_do_bit;    Set Data=1
sbrs r16,7;		Skip next if Bit 7 is set
cbi PORTD,pga_do_bit;    Set Data=0

sbi PORTD,pga_clk_bit;   Set CLK=Hi
rol r16;		Shift r16 1 to left
cbi PORTD,pga_clk_bit;   Set CLK=Lo

dec r17;		counter--
brne pga_sv_loop1;	counter=0? -> No -> again

dec r18;		
breq pga_sv_end;	loopcounter=0? -> No -> again
mov r16,r0;		Load the vol value into shift register
ldi r17,8;	        Set counter to 8
rjmp pga_sv_loop1;





pga_sv_end:
sbi PORTD,pga_cs_bit;    Set CS =Hi


ret;


;*********** increase Volume an set PGA *****************
;*********** r0=Volume (R&L)            *****************

pga_incvol:
mov r16,r0;		store value at r16
cpi r16,$FF;		volume = 255 ?
breq pga_incvol_max;    Yes -> Jump

inc r16;		r16++

pga_incvol_max:
mov r0,r16;		store value back

rcall pga_sendvol;
ret;

;*********** decrease Volume an set PGA *****************
;*********** r0=Volume (R&L)            *****************

pga_decvol:
mov r16,r0;		store value at r16
cpi r16,$00;		volume = 0 ?
breq pga_incvol_min;    Yes -> Jump

dec r16;		r16--

pga_incvol_min:
mov r0,r16;		store value back

rcall pga_sendvol;
ret;


