





.def Volume		= r0;
.def sw_cycle_counter 	= r1;
.def sw_status		= r2;	holds the switch status
		            ;   0 -> no sw pressed in last time
		            ;	1 -> sw_up  was pressed
			    ;   2 -> sw_dwn was pressed
.def IR_to		= r3;			    
.def int0s		= r25;			    


.org 0	
		rjmp reset;	Reset Int Vector
		reti ;rjmp INT0;	Int 0 Vector
		reti ;		Timer 0 Ovf
		reti ;		Ana Comp Int Vector

;********************************************************************
;* "INT0" - INT0  interrupt handler
;*
;********************************************************************

INT_0:		cli ;	Clear ALL Int's	
		reti ;
		in	S,sreg
		
		ldi r16,2;
		mov sw_status,r16;	
		ldi r16,0;
		out GIMSK,r16;	disable INT0
		out	sreg,S
		;		enable ALL Int's
		reti



reset:

	

rjmp main;
.equ maxvolume=220;			Set maximum Startvolume
.include "1200DEF.INC"

;************** Version for Up/Dwn switch *****************
;************** With    IR Control        *****************

.include "PGA2310.asm"
.include "EEPROM.asm"
.include "Switch_IR.asm"
.include "timer.asm"
.include "IR_Sony2.asm"



main:

rcall pga_init;
rcall timer_init_switch;
rcall EEP_readvol;

;mov r16,r0;
;cpi r16,maxvolume;
;brlo main_volok;

;ldi r16,maxvolume;
;mov r0,r16;
main_volok:
rcall pga_decvol;		dec volume & set

ldi r16,0;
mov sw_status,r16;		No switch pressed the last time :-)
mov sw_cycle_counter,r16;	Clear Cycle Counter

ldi r16,$FF;
mov command,r16;	
mov system,r16;	
;in r16,MCUCR;
;ori r16,3;
;out MCUCR,r16;			set rising edge

;ldi r16,$40 ;			enable INT0
;out GIMSK,r16;
;sei;



;******** Init ends here ***********



mainloop:

rcall switch_check;		read switches
;mov r16,sw_status;		switch pressed the last time?
cpi r16,0;
brne main_notcheckir;		Yes -> No IR
; call IR Startup
; call IR Routine
rcall 	IR_Init;
rcall 	IR_REC;


		;cpi system,$FF;
		;breq nomaindebug;
	
	rjmp nomaindebug;
	
					
		mov r16,system;
		ldi r17,$10;
		rcall EEP_store;
		
		mov r16,command;
		ldi r17,$11;
		rcall EEP_store;
		
		
		
		
		
		nomaindebug:
		
		
cpi command,$FF;
breq mainloop;

rjmp main_IR_INC;


rjmp mainloop;			check IR until switch




;****  below only switches can change settings!
main_notcheckir:
cli;				Stop ALL Int's
rcall timer_init_switch;
ldi r16,0;
mov sw_cycle_counter,r16;	clr cycle_counter



main_switchloop:

	rcall switch_check;		read switches

	cpi r16,1;			switch up?
	brne main_check_dwn;		No -> Jump & check down

	rcall pga_incvol;		inc volume & set
	ldi r16,40;			wait 40ms
	rcall timer_waitnms;
	rjmp main_checked_switch;	exit switch checking


	main_check_dwn:
	cpi r16,2;			switch down?			
	brne main_check_nothing;	No -> Jump & exit switch checking

	
	rcall pga_decvol;		dec volume & set
	ldi r16,40;			wait 40ms
	rcall timer_waitnms;
	rjmp main_checked_switch;	exit switch checking

	
	
	main_check_nothing:		;*** No switch was pressed
	
	ldi r16,10;			wait 10ms
	rcall timer_waitnms;
        
        nop;
        nop;
        nop;
        nop;
        
        
        mov r16,sw_cycle_counter;
        inc r16;
        cpi r16,100;			No more switch since 100x10ms?
        breq end_switchloop;		Yes -> exit switch loop
        mov sw_cycle_counter,r16;
        rjmp main_switchloop;
        
	main_checked_switch:		;*** a switch was pressed
        clr r16;
        mov sw_cycle_counter,r16;	
        rjmp main_switchloop;		and again.....


end_switchloop:



ldi r16,0;
mov sw_status,r16;			clear status
;ldi r16,$40 ;				enable INT0
;out GIMSK,r16;
;sei ;					enable ALL Int's



rjmp mainloop;


main_IR_INC:
rcall pga_incvol;		inc volume & set
rjmp mainloop;


main_IR_DEC:
rcall pga_decvol;		dec volume & set
rjmp mainloop;